{*****************************************************************************}
{*                                                                           *}
{*                         Turbo Pascal Version 5.0                          *}
{*                          UniCRT Interface Unit                            *}
{*                                                                           *}
{*                 (c) 1990 Software R&D Laboratory, Sofia                   *}
{*                                                                           *}
{*****************************************************************************}

{$A-,B-,D-,E-,F-,I-,L-,N-,O-,R-,S+,V-}

unit UniCRT; interface

  const 							  { CRT modes }
	BW40	= 0;				 { 40x25 B/W on Color Adapter }
	CO40	= 1;			       { 40x25 Color on Color Adapter }
	BW80	= 2;				 { 80x25 B/W on Color Adapter }
	CO80	= 3;			       { 80x25 Color on Color Adapter }
	Mono	= 7;				{ 80x25 on Monochrome Adapter }
	Font8x8 = 256;					{ Add-in for ROM font }

       { Foreground   and   background color constants }

	Black	  = 0;	    DarkGray	 =  8;
	Blue	  = 1;	    LightBlue	 =  9;
	Green	  = 2;	    LightGreen	 = 10;
	Cyan	  = 3;	    LightCyan	 = 11;
	Red	  = 4;	    LightRed	 = 12;
	Magenta   = 5;	    LightMagenta = 13;
	Brown	  = 6;	    Yellow	 = 14;
	LightGray = 7;	    White	 = 15;

	Blink	      = 128;				{ Add-in for blinking }


  var							{ Interface variables }
      CheckBreak:  boolean;				  { Enable Ctrl-Break }
      CheckEOF:    boolean;				      { Enable Ctrl-Z }
      DirectVideo: boolean;		     { Enable direct video addressing }
      CheckSnow:   boolean;			      { Enable snow filtering }
      LastMode:    word;				  { Current text mode }
      TextAttr:    byte;			     { Current text attribute }
      WindMin:	   word;		      { Window upper left coordinates }
      WindMax:	   word;		     { Window lower right coordinates }
      ScrXsize,
      ScrYsize:    byte;                                        { Screen size }

  { Interface procedures }

  procedure AssignCrt(var F: text);

  function  KeyPressed: boolean;
  function  ReadKey: char;

  procedure GotoXY(X,Y: byte);

  function  WhereX: byte;
  function  WhereY: byte;

  procedure ClrScr;
  procedure ClrEol;

  procedure NormVideo;

  procedure SetTextAttr(Attr: byte);

  procedure SetCursor(n: byte { 0..4 });

implementation {$L Crt.Obj }

  procedure AssignCrt(var F: text);				      external;

  function  KeyPressed: boolean;				      external;
  function  ReadKey: char;					      external;

  procedure GotoXY(X,Y: byte);					      external;
  function  WhereX: byte;					      external;
  function  WhereY: byte;					      external;

  procedure ClrScr;						      external;
  procedure ClrEol;						      external;

  procedure NormVideo;						      external;
  procedure SetTextAttr(Attr: byte);                                  external;

  procedure SetCursor(n: byte { 0..4 });                              external;

  procedure InitPart2;						      external;

begin { UniCRT }
InitPart2;
ScrXsize:= succ(Lo(WindMax));
ScrYsize:= succ(Hi(WindMax));
end { UniCrt }.
